/* $Id: ppc.c,v 1.1 2004/01/12 01:55:40 mikpe Exp $
 * PPC32-specific perfctr library procedures.
 *
 * Copyright (C) 2004  Mikael Pettersson
 */
#include <stdio.h>
#include "libperfctr.h"

unsigned int perfctr_info_nrctrs(const struct perfctr_info *info)
{
    return 2;
}

const char *perfctr_info_cpu_name(const struct perfctr_info *info)
{
    return "PowerPC 60x/7xx/74xx";
}

void perfctr_cpu_control_print(const struct perfctr_cpu_control *control)
{
    unsigned int i, nractrs, nrictrs, nrctrs;

    nractrs = control->nractrs;
    nrictrs = control->nrictrs;
    nrctrs = control->nractrs + nrictrs;

    printf("tsc_on\t\t\t%u\n", control->tsc_on);
    printf("nractrs\t\t\t%u\n", nractrs);
    if( nrictrs )
	printf("nrictrs\t\t\t%u\n", nrictrs);
    for(i = 0; i < nrctrs; ++i) {
	printf("pmc_map[%u]\t\t%u\n", i, control->pmc_map[i]);
        printf("evntsel[%u]\t\t0x%08X\n", i, control->evntsel[i]);
	if( i >= nractrs )
	    printf("ireset[%u]\t\t%d\n", i, control->ireset[i]);
    }
    if( control->ppc.mmcr0 )
	printf("mmcr0\t\t\t0x%08X\n", control->ppc.mmcr0);
    if( control->ppc.mmcr2 )
	printf("mmcr2\t\t\t0x%08X\n", control->ppc.mmcr2);
}
